/***********************************************************************************
* STasks
* Copyright (C) 2009 Marcin Baszczewski <marcin.baszczewski@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*
***********************************************************************************/

#ifndef STASKSWINDOWPREVIEW_H
#define STASKSWINDOWPREVIEW_H

#include <QWidget>
#include <QSize>
#include <QMouseEvent>

#include <Plasma/FrameSvg>

class STasksWindowPreview : public QWidget
{
    Q_OBJECT

    public:
        STasksWindowPreview(QPixmap pixmap, QWidget *parent);
        ~STasksWindowPreview();

        void setWindow(WId window);

        friend class STasksToolTip;

    protected:
        void paintEvent(QPaintEvent *event);
        void enterEvent(QEvent *event);
        void leaveEvent(QEvent *event);
        void mousePressEvent(QMouseEvent *event);

    public slots:
        void updateTheme();

    private:
        Plasma::FrameSvg *m_background;
        QPixmap m_pixmap;
        WId m_window;
        qreal m_opacity;
};

#endif
